'use strict';

var React = require('react');
var TextField = require('lore-react-forms-bootstrap/TextField');
// var CheckboxField = require('../lib/react-form-bootstrap/CheckboxField');
// var NumberField = require('../lib/react-form-bootstrap/NumberField');
var SelectField = require('lore-react-forms-bootstrap/SelectField');
var DynamicTextField = require('lore-react-forms-bootstrap/DynamicTextField');
var AutoCompleteField = require('lore-react-forms-bootstrap/AutoCompleteField');
var ConfigConnect = require('./ConfigConnect');
var Connect = null;

module.exports = {

  templates: {
    default: require('lore-react-forms/Template')
  },

  typeFieldMap: {

    string: function string(name, attributes) {
      return React.createElement(TextField, {
        label: attributes.label,
        name: name
      });
    },

    dynamicString: function dynamicString(name, attributes) {
      Connect = Connect || ConfigConnect();
      return React.createElement(
        Connect,
        { callback: attributes.connect },
        React.createElement(DynamicTextField, {
          label: attributes.label,
          name: name,
          getMessage: attributes.getMessage
        })
      );
    },

    // text: function(name, attributes) {
    //   return (
    //     <TextField
    //       label={attributes.label}
    //       name={name}
    //       multiLine={true}
    //     />
    //   );
    // },
    //
    // checkbox: function(name, attributes) {
    //   return (
    //     <CheckboxField
    //       label={attributes.label}
    //       name={name}
    //     />
    //   );
    // },
    //
    // number: function(name, attributes) {
    //   return (
    //     <NumberField
    //       label={attributes.label}
    //       name={name}
    //     />
    //   );
    // },

    select: function select(name, attributes) {
      Connect = Connect || ConfigConnect();
      return React.createElement(
        Connect,
        { callback: attributes.getOptions },
        React.createElement(SelectField, {
          label: attributes.label,
          name: name,
          field: attributes.field || 'username'
        })
      );
    },

    autocomplete: function autocomplete(name, attributes) {
      Connect = Connect || ConfigConnect();
      return React.createElement(
        Connect,
        { callback: attributes.getOptions },
        React.createElement(AutoCompleteField, {
          label: attributes.label,
          name: name,
          field: attributes.field || 'username'
        })
      );
    }

  },

  typeActionMap: {

    cancel: function cancel(name, attributes) {
      return React.createElement(
        'button',
        {
          key: name,
          className: 'btn btn-default' },
        attributes.label || 'Cancel'
      );
    },

    submit: function submit(name, attributes, onSubmit) {
      return React.createElement(
        'button',
        {
          key: name,
          className: 'btn btn-primary',
          onClick: onSubmit },
        attributes.label || 'Submit'
      );
    }

  }

};